<template>
	<div class="statistics-order-hotspot-container layout-pd">
		<!-- 搜索  -->
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item label="时间段" prop="crTime">
					<el-date-picker
						v-model="state.queryParams.crTime"
						type="datetimerange"
						unlink-panels
						range-separator="至"
						start-placeholder="开始时间"
						end-placeholder="结束时间"
						:shortcuts="shortcuts"
						@change="queryList"
						value-format="YYYY-MM-DD[T]HH:mm:ss"
					/>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				border
				:pagination="false"
				:key="Math.random()"
				show-summary
				row-key="OrgCode"
			>
			</ProTable>
		</el-card>
	</div>
</template>
<script setup lang="ts" name="statisticsOrderOrgHotspot">
import { onMounted, reactive, ref } from 'vue';
import { ElButton, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { departmentHotDetail } from '@/api/statistics/order';
import { shortcuts } from '@/utils/constants';
import dayjs from 'dayjs';
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive(<any>{
	queryParams: {
		// 查询条件
		crTime: [dayjs().startOf('day').format('YYYY-MM-DD HH:mm:ss'), dayjs().endOf('day').format('YYYY-MM-DD HH:mm:ss')], // 时间默认今天开始到今天结束
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});

const columns = ref<any>([]); // 表头
/** 获取列表 */
const queryList = throttle(() => {
	state.loading = true;
	let StartTime = null;
	let EndTime = null;
	if (state.queryParams?.crTime) {
		StartTime = state.queryParams?.crTime[0];
		EndTime = state.queryParams?.crTime[1];
	}
	const request = {
		StartTime,
		EndTime,
	};
	departmentHotDetail(request)
		.then((res: any) => {
			columns.value = res.result?.hotSpot ?? [];
			columns.value = columns.value.map((item: any) => {
				return {
					prop: item.id,
					label: item.hotSpotName,
					minWidth: 120,
					align: 'center',
					id: item.id,
				};
			});
			columns.value.unshift(
				{
					prop: 'OrgName',
					label: '部门名称',
					minWidth: 140,
				},
				{
					prop: 'sum',
					label: '小计',
					width: 55,
					align: 'center',
				}
			);
			state.tableData = res.result?.data ?? [];
			// 判断部门名称是否重复 重复的合并数据 并去除重复数据
			const arr = <any>[];
			state.tableData.forEach((item: any) => {
				const index = arr.findIndex((v: any) => v.OrgName === item.OrgName);
				if (index === -1) {
					arr.push(item);
				} else {
					arr[index] = Object.assign(arr[index], item);
				}
			});
			// 添加合计
			arr.forEach((item: any) => {
				item.sum = 0;
				columns.value.forEach((v: any) => {
					if (v.id !== 'sum' && v.id !== 'OrgName') {
						item.sum += item[v.id] ?? 0;
					}
				});
			});
			state.tableData = arr;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
}, 300);
/** 重置按钮操作 */
const resetQuery = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
}, 300);

onMounted(() => {
	queryList();
});
</script>
